import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.Socket;
import java.net.URL;


public class RequestProcessor implements Runnable {

	private Socket s;
	private UserAgent agents;

	public RequestProcessor(Socket request,UserAgent agent) {
		this.agents = agent;
		this.s = request;
	}

	public void run( ) {
		try {
			Writer out = new OutputStreamWriter(s.getOutputStream(),"ASCII");
			BufferedReader br = new BufferedReader(new InputStreamReader(s.getInputStream( ),"ASCII"));
			//Richiesta
			String get = br.readLine();
			System.out.println(get);
			String[] getElement = get.split(" ");
			String method = getElement[0];
			String protocol = getElement[2];
			if (method.equals("GET") && (protocol.equals("HTTP/1.0") || protocol.equals("HTTP/1.1") )) {
				try{
					while(!(get=br.readLine()).equals("")){
						if(get.toLowerCase().startsWith("user-agent")){
							String user = get.substring(get.indexOf(":")+1);
							agents.addUserAgent(user.trim());
						}
					}
					out.write("GET corretto\r\n");
					out.flush();
				}catch(MalformedURLException mue){
					out.write("Richiesta non corretta\r\n");
					out.flush();
				}

			}
			else {
				out.write("Richiesta non accettata\r\n");
			}
		}
		catch (IOException ex) {
		}
		finally {
			try {
				s.close( );
			}
			catch (IOException ex) {}
		}
	}
	public static String guessContentTypeFromName(String name) {
		if (name.endsWith(".html") || name.endsWith(".htm")) {
			return "text/html";
		}
		else if (name.endsWith(".txt") || name.endsWith(".java")) {
			return "text/plain";
		}
		else if (name.endsWith(".gif")) {
			return "image/gif";
		}
		else if (name.endsWith(".class")) {
			return "application/octet-stream";
		}
		else if (name.endsWith(".jpg") || name.endsWith(".jpeg")) {
			return "image/jpeg";
		}
		else return "text/plain";
	}
}
